<?php
/***********************************************************************************
 *
 * 	SETTINGS PAGE
 *
 ***********************************************************************************/
if (!function_exists('add_action')) exit;

if (isset($_POST['action']) && 'save_settings' === $_POST['action'])
{	// SAVE SETTINGS
	check_admin_referer('fab_settings_'.$this->fab_version);

	$safe_keycode = intval($_POST['fab_keycode']);
	if (!$safe_keycode) $safe_keycode = '';
	if (strlen($safe_keycode) > 3) $safe_keycode = substr($safe_keycode, 0, 3);

	if (isset($_POST['fab_initial_button']))
		$this->fab_options['initial_button'] = $_POST['fab_initial_button'];
	else
		$this->fab_options['initial_button'] = 'N';
	$_SESSION['fab_initial_button'] = $this->fab_options['initial_button'];
		
	if (isset($_POST['fab_button_enabled']))
		$this->fab_options['button_enabled'] = $_POST['fab_button_enabled'];
	else
		$this->fab_options['button_enabled'] = 'N';		

	if(isset($this->fab_options['shift_ctrl'])) $this->fab_options['shift_ctrl'] = sanitize_text_field($_POST['fab_shift_ctrl']);
	if(isset($this->fab_options['keycode'])) $this->fab_options['keycode']   = $safe_keycode;
	if(isset($_POST['fab_position']))     $this->fab_options['position']     = sanitize_text_field($_POST['fab_position']);
	if(isset($_POST['fab_horz_spacing'])) $this->fab_options['horz_spacing'] = sanitize_text_field($_POST['fab_horz_spacing']);
	if(isset($_POST['fab_vert_spacing'])) $this->fab_options['vert_spacing'] = sanitize_text_field($_POST['fab_vert_spacing']);	
	if(isset($_POST['fab_scrolltext']))   $this->fab_options['scrolltext']   = sanitize_text_field($_POST['fab_scrolltext']);
	if(isset($_POST['fab_adminurl']))     $this->fab_options['adminurl']     = sanitize_text_field($_POST['fab_adminurl']);
		
	update_option('fab_options', $this->fab_options);
	
	echo '<div class="updated"><p><strong>'.__('Floating Admin Button - Settings UPDATED!', $this->fab_text_domain).'</strong></p></div>';
} // if (isset($_POST['action']) && 'save_settings' === $_POST['action'])
?>
<?PHP
/***********************************************************************************
 * 	TITLE BAR
 ***********************************************************************************/
?>
<div class="fab-title-bar">
  <h2><?php _e('Floating Admin Button - Settings', $this->fab_text_domain); ?></h2>
</div>
<?php
/***********************************************************************************
 * 	INTRO
 ***********************************************************************************/
?>
<div class="fab-intro">
  <?php _e('Plugin version', $this->fab_text_domain); ?>: v<?php echo $this->fab_version?> [<?php echo $this->fab_release_date?>] - <a href="<?php echo $this->fab_plugin_page?>" target="_blank"><?php _e('Plugin page', $this->fab_text_domain); ?></a> - <a href="<?php echo $this->fab_download_page?>" target="_blank"><?php _e('Download page', $this->fab_text_domain); ?></a> - <a href="<?php echo $this->fab_donation_page?>" target="_blank"><?php _e('Donation page', $this->fab_text_domain); ?></a> </div>
<?php
/***********************************************************************************
 * 	FORM
 ***********************************************************************************/
$fab_dragged_text = '';
if(isset($_SESSION['fab_bottom']))
{	// BUTTON HAS BEEN DRAGGED DURING THIS SESSION
	$fab_dragged_text = __('Button has been dragged, new Position is', $this->fab_text_domain);
	$fab_dragged_text .= ' ';
	$fab_dragged_text .= __('LEFT:', $this->fab_text_domain);
	$fab_dragged_text .= ' ';
	$fab_dragged_text .= $_SESSION['fab_left'].'px, ';
	$fab_dragged_text .= __('BOTTOM:', $this->fab_text_domain);
	$fab_dragged_text .= ' ';
	$fab_dragged_text .= $_SESSION['fab_bottom'].'px';	
}
$fab_ajax_url = admin_url('admin-ajax.php'); 
?>
<script type="text/javascript">
function fab_enable_changed()
{	// alert(jQuery("#fab_button_enabled").prop("checked"));
	if(!jQuery("#fab_button_enabled").prop("checked"))
	{	// DISABLED
		jQuery("#fab_initial_button").prop("disabled", true);
		jQuery("#fab_position").prop("disabled", true);
		jQuery("#fab_horz_spacing").prop("disabled", true);
		jQuery("#fab_vert_spacing").prop("disabled", true);
		jQuery("#fab_scrolltext").prop("disabled", true);
		jQuery("#fab_adminurl").prop("disabled", true);
		jQuery("#fab_reset_adminurl").prop("disabled", true);
		jQuery("#fab_key_combination").html("<?php _e('Key Combination for switching<br>the WP-Admin Bar ON or OFF', $this->fab_text_domain); ?>");
		jQuery("#fab_note_dragging").removeClass("fab-note");
		jQuery("#fab_dragged_text").removeClass("fab-note");
		jQuery("#fab_reset_button").prop("disabled", true);
		jQuery(".fab-gray-out").addClass("fab-text-disabled");
	}
	else
	{	// ENABLED
		jQuery("#fab_initial_button").prop("disabled", false);
		jQuery("#fab_position").prop("disabled", false);
		jQuery("#fab_horz_spacing").prop("disabled", false);
		jQuery("#fab_vert_spacing").prop("disabled", false);
		jQuery("#fab_scrolltext").prop("disabled", false);
		jQuery("#fab_adminurl").prop("disabled", false);
		jQuery("#fab_reset_adminurl").prop("disabled", false);
		jQuery("#fab_key_combination").html("<?php _e('Key Combination for toggling between<br>Floating Button and WP-Admin Bar', $this->fab_text_domain); ?>");
		jQuery("#fab_note_dragging").addClass("fab-note");
		jQuery("#fab_dragged_text").addClass("fab-note");
		jQuery("#fab_reset_button").prop("disabled", false);		
		jQuery(".fab-gray-out").removeClass("fab-text-disabled");
	}
}

// RESET THE LINK OF THE BUTTON TO THE DEFAULT ADMIN PAGE
function fab_reset_url()
{
	jQuery("#fab_adminurl").val("<?php echo admin_url();?>");
}
</script>
<div id="fab-settings-form">
  <form name="fab_settings" id="fab_settings" method="post" action="">
    <?php wp_nonce_field('fab_settings_'.$this->fab_version); ?>
    <input type="hidden" name="action" value="save_settings" />
    <table border="0" cellspacing="0" cellpadding="5">
      <?php
		$fab_initial_button_checked = '';
		if(isset($this->fab_options['initial_button']))
			if ($this->fab_options['initial_button'] == 'Y')
				$fab_initial_button_checked = ' checked="checked"';
		$fab_button_enabled_checked = '';
		if(isset($this->fab_options['button_enabled']))
			if ($this->fab_options['button_enabled'] == 'Y')
				$fab_button_enabled_checked = ' checked="checked"';				
		?>
      <tr>
        <td valign="top"><?php _e('Enable Floating Admin button', $this->fab_text_domain); ?></td>
        <td valign="top"><input type="checkbox" name="fab_button_enabled" id="fab_button_enabled" value="Y" <?php echo $fab_button_enabled_checked;?> onchange="fab_enable_changed();" /></td>
      </tr>
      <tr>
        <td valign="top" colspan="2" class="fab-note"><?php _e('Note: select a Key Combination that is not already used by your Browser!', $this->fab_text_domain);?></td>
      </tr>
      <tr>
        <td valign="top"><span id="fab_key_combination"></span></td>
        <td valign="top"><select name="fab_shift_ctrl" id="fab_shift_ctrl">
            <option value="shift"><?php _e('Shift', $this->fab_text_domain);?></option>
            <option value="ctrl"><?php _e('Ctrl', $this->fab_text_domain);?></option>
          </select>
          &nbsp;
          <select name="fab_keycode" id="fab_keycode">
            <option value="112"><?php _e('F1', $this->fab_text_domain);?></option>
            <option value="113"><?php _e('F2', $this->fab_text_domain);?></option>
            <option value="114"><?php _e('F3', $this->fab_text_domain);?></option>
            <option value="115"><?php _e('F4', $this->fab_text_domain);?></option>
            <option value="116"><?php _e('F5', $this->fab_text_domain);?></option>
            <option value="117"><?php _e('F6', $this->fab_text_domain);?></option>
            <option value="118"><?php _e('F7', $this->fab_text_domain);?></option>
            <option value="119"><?php _e('F8', $this->fab_text_domain);?></option>
            <option value="120"><?php _e('F9', $this->fab_text_domain);?></option>
            <option value="121"><?php _e('F10', $this->fab_text_domain);?></option>
            <option value="122"><?php _e('F11', $this->fab_text_domain);?></option>
            <option value="123"><?php _e('F12', $this->fab_text_domain);?></option>
          </select></td>
      </tr>
<script type="text/javascript">
jQuery('#fab_shift_ctrl').val("<?php echo $this->fab_options['shift_ctrl'];?>");
jQuery('#fab_keycode').val("<?php echo $this->fab_options['keycode'];?>");	  
</script>
      <tr>
        <td valign="top" colspan="2">- - - - -</td>
      </tr>
      <tr>
        <td valign="top" class="fab-gray-out"><?php _e('Initially show the Floating Admin Button<br />instead of the WP Admin Bar', $this->fab_text_domain); ?></td>
        <td valign="top"><input type="checkbox" name="fab_initial_button" id="fab_initial_button" value="Y" <?php echo $fab_initial_button_checked;?> /></td>
      </tr>
      <tr>
        <td valign="top" colspan="2" class="fab-note fab-gray-out" id="fab_note_dragging"><?php _e('Note: dragging the Button will (temporary) overwrite the default Position!', $this->fab_text_domain);?></td>
      </tr>
      <tr>
        <td valign="top" class="fab-gray-out"><?php _e('Default Position of the Button', $this->fab_text_domain); ?></td>
        <td valign="top"><select name="fab_position" id="fab_position">
            <option value="lowerright"><?php _e('Lower Right', $this->fab_text_domain);?></option>
            <option value="lowerleft"><?php _e('Lower Left', $this->fab_text_domain);?></option>
            <option value="upperright"><?php _e('Upper Right', $this->fab_text_domain);?></option>
            <option value="upperleft"><?php _e('Upper Left', $this->fab_text_domain);?></option>
          </select>
          <?php
		  if($fab_dragged_text)
		  {
		  ?>
          <span class="fab-note fab-gray-out" id="fab_dragged_text"><br />
          <?php echo $fab_dragged_text; ?><br />
          <input class="button-primary button-large fab-reset-button" type='button' name="fab-reset-button" id="fab_reset_button" value="<?php echo __('Back to Default Position', $this->fab_text_domain);?>" onclick="fab_reset_position('<?php echo $fab_ajax_url?>')"; />
          </span>
          <?php
		  }
		  ?></td>
      </tr>
<script type="text/javascript">
jQuery('#fab_position').val("<?php echo $this->fab_options['position'];?>");
</script>
      <tr>
        <td valign="top" class="fab-gray-out"><?php _e('Horizontal spacing', $this->fab_text_domain); ?></td>
        <td valign="top"><select name="fab_horz_spacing" id="fab_horz_spacing">
	        <option value="5px">5px</option>
	        <option value="10px">10px</option>
            <option value="15px">15px</option>
            <option value="20px">20px</option>
            <option value="50px">50px</option>
            <option value="75px">75px</option>
            <option value="100px">100px</option>
            <option value="150px">150px</option>
          </select></td>
      </tr>
      <script type="text/javascript">
      jQuery('#fab_horz_spacing').val("<?php echo $this->fab_options['horz_spacing'];?>");
      </script>
      <tr>
        <td valign="top" class="fab-gray-out"><?php _e('Vertical spacing', $this->fab_text_domain); ?></td>
        <td valign="top"><select name="fab_vert_spacing" id="fab_vert_spacing">
	        <option value="5px">5px</option>
	        <option value="10px">10px</option>
            <option value="15px">15px</option>
            <option value="20px">20px</option>
            <option value="50px">50px</option>
            <option value="75px">75px</option>
            <option value="100px">100px</option>
            <option value="150px">150px</option>
          </select></td>
      </tr>
      <script type="text/javascript">
      jQuery('#fab_vert_spacing').val("<?php echo $this->fab_options['vert_spacing'];?>");
      </script>      
      <tr>
        <td valign="top" class="fab-gray-out"><?php _e('Title for the Button', $this->fab_text_domain); ?></td>
        <td valign="top"><input name="fab_scrolltext" id="fab_scrolltext" type="text" value="<?php echo $this->fab_options['scrolltext'];?>" size="40" /></td>
      </tr>
      <tr>
        <td valign="top" class="fab-gray-out"><?php _e('Link for the button', $this->fab_text_domain); ?></td>
        <td valign="top"><input name="fab_adminurl" id="fab_adminurl" type="text" value="<?php echo $this->fab_options['adminurl'];?>" size="40" /><input class="button" name="fab_reset_adminurl" id="fab_reset_adminurl" value="<?php echo __('Reset URL', $this->fab_text_domain);?>" type="button" onclick="fab_reset_url();" /></td>
      </tr>
      <tr>
        <td colspan="2"><input class="button-primary button-large fab-save-button" type='submit' name='info_update' value='<?php echo __('Save Settings', $this->fab_text_domain);?>' /></td>
      </tr>
    </table>
  </form>
<script type="text/javascript">
fab_enable_changed();
</script> 
</div>
<?php
include(ABSPATH.'wp-admin/admin-footer.php');
// JUST TO BE SURE
die;
?>
